<?php
namespace Teknisa\PAR\Controller;

use Teknisa\PAR\Controller\TeknisaCrud;
use Teknisa\PAR\Service\ComunicacaoService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;

class ComunicacaoController extends TeknisaCrud {

    protected $comunicacaoService;
    protected $crudService;
    protected $dataSourceName = "comunicaparc_formacomu";
    protected $parameterBagColumns = array("P_NRPARCNEGOCIO", "P_NRORG");

    public function __construct($crudService, ParameterBag $parameterBag, ComunicacaoService $comunicacaoService) {
        $this->crudService = $crudService;
        $this->comunicacaoService = $comunicacaoService;
        parent::__construct($crudService, $parameterBag);
    }

    public function save(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $nrcomunicaparc = $this->comunicacaoService->validateComunicacao($row);
            parent::save($request, $response);
            if ($row["__is_new"]) {
                $response->addDataset(new DataSet("columnsToReturn", $this->crudService->getColumnsToReturn()));
            }
        }
        catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

}