<?php
namespace Teknisa\PAR\Factory;

use Doctrine\ORM\EntityManager;

class crm00004000LeadFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function verifyLeadInsc($paramsVerifyLeadCPNJ, $tabela, $fieldInscricao, $fieldNome){
        $select = "SELECT {$fieldNome}
                     FROM {$tabela}
                    WHERE {$fieldInscricao} = :INSCRICAO
                      AND NRORG = :NRORG  ";
                      
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsVerifyLeadCPNJ);
            $leads = $std->fetchAll();
            return $leads;
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function verifyLeadCNPJ($paramsVerifyLeadCPNJ, $tabela, $fieldInscricao, $fieldNome){
        $select = "SELECT {$fieldNome}
                     FROM {$tabela}
                    WHERE {$fieldInscricao} LIKE('%'|| :INSCRICAO || '%')
                      AND NRORG = :NRORG  ";
                      
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsVerifyLeadCPNJ);
            $leads = $std->fetchAll();
            return $leads;
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function verifyLeadName($paramsVerifyLeadName, $tabela, $fieldNome){
        $select = "SELECT {$fieldNome}
                     FROM {$tabela}
                    WHERE UPPER({$fieldNome}) LIKE('%'|| :NOME || '%')
                      AND NRORG = :NRORG  ";
                      
        try{
            $std = $this->connection->prepare($select);
            $std->execute($paramsVerifyLeadName);
            $leads = $std->fetchAll();
            return $leads;
        }
        catch(\Exception $e){
            throw $e;
        };
    }
    
    public function insertLeadEvolNextTask($paramsInsertLeadEvolNextTask){

        $insert = "INSERT INTO FILACONTATO (DSFILACONTATO,DTPLANFILACONTA,CDOPERREAL,NRSEQFILACONTA,NRORG,DTINCLUSAO,NRORGINCLUSAO,
                               CDOPERINCLUSAO,NRPARCNEGOCIO,IDORIGFILACONTA,IDATIVO,NRCONTATO,NRSEQCONTATO, NRSEQCLASSIFICATAREFA)
                    VALUES (:DSFILACONTATO,
                            :DTPLANFILACONTA,
                            :CDOPERREAL,
                            :NRSEQFILACONTA,
                            :NRORG,
                             SYSDATE,
                            :NRORGINCLUSAO,
                            :CDOPERINCLUSAO,
                            :NRPARCNEGOCIO,
                             'M',
                             'S',
                            :NRCONTATO,
                            :NRSEQCONTATO,
                            :NRSEQCLASSIFICATAREFA)";
                 
        try{
            $std = $this->connection->prepare($insert);
            $std->execute($paramsInsertLeadEvolNextTask);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
       
    public function requestForSetTaskEndDate($paramsSetTaskEndDate){
        
        $update = "UPDATE FILACONTATO 
                   SET DTREALFILACONTA = SYSDATE
                   WHERE NRSEQFILACONTA = :NRSEQFILACONTA";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsSetTaskEndDate);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function getLimiteLeadsPorRevendaParametrizacao($nrorg){
        
        $select = "SELECT DECODE(NRLIMITELEADREVENDA, NULL, 'SEM_LIMITE', NRLIMITELEADREVENDA) NRLIMITELEADREVENDA FROM CRM_PARAMETRIZACAO WHERE NRORG = '$nrorg'";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $limite = $std->fetchAll();
            
            if(is_array($limite)){
                return $limite[0]['NRLIMITELEADREVENDA'];
            }
            return $limite;
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function getQuantidadeLeadsOperador($parcOperador, $nrorg){
        
        $select = "SELECT COUNT(NRCANDIDATO) QUANTIDADE FROM CRM_CANDIDATO WHERE NRORG = '$nrorg' AND NRPARCPROPRI = '$parcOperador' ";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $quantidadeOperador = $std->fetchAll();
            if(is_array($quantidadeOperador)){
                return $quantidadeOperador[0]['QUANTIDADE'];
            }
            return $quantidadeOperador;
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForDeactivateLeadTask($paramsDeactivateTask){
        
        $update = "UPDATE FILACONTATO 
                   SET IDATIVO = 'N'
                   WHERE NRSEQFILACONTA = :NRSEQFILACONTA";
        
        try{
            $std = $this->connection->prepare($update);
            $std->execute($paramsDeactivateTask);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestForInsertProspectInterlocutor($paramsInsertInterlocutor){
        
        $insertInterlocutor = "INSERT INTO CRM_INTERLOCUTOR ( NRSEQINTERLOCUTOR, NMINTERLOCUTOR, 
        NRPARCNEGOCIO, CDCARGOINTERLOC, IDRECEBEPRESENTE, EMAILINTERLOC, NRTELEFONE1, DTINCLUSAO, NRORG)
                               VALUES(:NRSEQINTERLOCUTOR,
                                      :NMINTERLOCUTOR,
                                      :NRPARCNEGOCIO,
                                      :CDCARGOINTERLOC,
                                      :IDRECEBEPRESENTE,
                                      :EMAILINTERLOC,
                                      :NRTELEFONE1,
                                       SYSDATE,
                                      :NRORG)";
        
        try{
            $std = $this->connection->prepare($insertInterlocutor);
            $std->execute($paramsInsertInterlocutor);
        }
        catch(\Exception $e){
            throw $e;
        };
        
    } 
    
    public function requestToSetLeadIdAtivo($updateParams){
    
        $updateLead = "UPDATE CRM_CANDIDATO 
                        SET IDATIVO = :IDATIVO
                        WHERE NRCANDIDATO = :NRCANDIDATO";
        
        try{
            $std = $this->connection->prepare($updateLead);
            $std->execute($updateParams);
        }catch(Exception $e){
            throw $e;
        }
    }
    
    public function getLimiteProspectsPorOperadorParametrizacao($nrorg){
        
        $select = "SELECT DECODE(NRLIMITEPROSPOPER, NULL, 'SEM_LIMITE', NRLIMITEPROSPOPER) NRLIMITEPROSPOPER FROM CRM_PARAMETRIZACAO WHERE NRORG = '$nrorg'";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $limite = $std->fetchAll();
            
            if(is_array($limite)){
                return $limite[0]['NRLIMITEPROSPOPER'];
            }
            return $limite;
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function getQuantidadeProspectsOperador($parcOperador, $nrorg){
        
        $select = "SELECT COUNT(CDPROSPECT) QUANTIDADE FROM PROSPECT WHERE NRORG = '$nrorg' AND NRPARCRESPROSP = '$parcOperador' ";
        
        try{
            $std = $this->connection->prepare($select);
            $std->execute();
            $quantidadeOperador = $std->fetchAll();
            if(is_array($quantidadeOperador)){
                return $quantidadeOperador[0]['QUANTIDADE'];
            }
            return $quantidadeOperador;
        }
        catch(\Exception $e){
            throw $e;
        };
        
    }
    
    public function requestToInsertProspectToResale($paramsInsert) {
        
        $insert = "INSERT INTO CRM_PROSPREVENDA 
                    (NRPROSPREVENDA, NRREVENDA, CDPROSPECT, NRPARCNEGOCIO, NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO, IDATIVO)
                    VALUES(
                        :NRPROSPREVENDA,
                        :NRREVENDA,
                        :CDPROSPECT,
                        :NRPARCNEGOCIO,
                        :NRORG,
                        SYSDATE,
                        :NRORG,
                        :CDOPERINCLUSAO,
                        :IDATIVO)";
        
        $std = $this->connection->prepare($insert);
        $std->execute($paramsInsert);
        
    }
    
    public function requestToUpdateLeadPartnership($insertParams){
        
        $update = "UPDATE PARCERIA
                   SET CDTIPOPARCEIRO = 'PROSPECT'
                   WHERE NRPARCERIA = :NRPARCERIA
                   AND NRORG = :NRORG";
        
        $std = $this->connection->prepare($update);
        $std->execute($insertParams);
        
    }
    
    public function requestToGetLeadPartnershipNumber($selectParams){
        
        $select = "SELECT NRPARCERIA
                   FROM PARCERIA
                   WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                   AND CDTIPOPARCEIRO = :CDTIPOPARCEIRO
                   AND NRORG = :NRORG";
        
        
        $std = $this->connection->prepare($select);
        $std->execute($selectParams);
        $partnershipNumber = $std->fetchAll();
        
        return $partnershipNumber;
        
    }
    
    public function requestToEditLeadResponsibleOperator($updateParams){
        
        $update = "UPDATE CRM_CANDIDATO
                   SET NRPARCPROPRI = :NEWNRPARCPROPRI
                   WHERE NRCANDIDATO = :NRCANDIDATO
                   AND NRORG = :NRORG";
        
        $std = $this->connection->prepare($update);
        $std->execute($updateParams);
        
    }
    
}
?>