<?php
namespace Teknisa\PAR\Service;

use Teknisa\Model\Util\NovoCodigo;

class crm00004000LeadSevice {
    
    protected $leadFactory;
    protected $newCode;
    
    public function __construct ($newCode, $leadFactory){
        $this->leadFactory = $leadFactory;
        $this->newCode     = $newCode;
    }
    
    public function validaLead($row){
        
        if(!empty($row['INSCRICAO'])){
            $paramsVerifyLeadCPNJ = array(
                "INSCRICAO"            => $row["INSCRICAO"],
                "NRORG"                => $row["NRORG"]
            );
            if($row['IDTPIJURCAN'] === 'J'){
                $leads = $this->leadFactory->verifyLeadCNPJ($paramsVerifyLeadCPNJ, $row['TABELA'], $row['FIELDINSC'], $row['FIELDNOME']);
            }else{
                $leads = $this->leadFactory->verifyLeadInsc($paramsVerifyLeadCPNJ, $row['TABELA'], $row['FIELDINSC'], $row['FIELDNOME']);
            }
        }else{
            $leads = array();
        }
        if(empty($leads)){
            
            $paramsVerifyLeadName = array(
                "NOME"                    => $row["NOME"],
                "NRORG"                   => $row["NRORG"]
            );
            
            $leads = $this->leadFactory->verifyLeadName($paramsVerifyLeadName, $row['TABELA'], $row['FIELDNOME']); 
            if(!empty($leads)){
                $leads = true;
            }else{
                $leads = false;
            }
            
        }
        
        return $leads;
    }
    
    public function verificaParametrizacaoProspect($row){
        
        $parcOperador   = $row['NRPARCNEGOCIOOPER'];
        $nrorg      = $row['NRORG'];
        
        $limite = $this->leadFactory->getLimiteProspectsPorOperadorParametrizacao($nrorg);
        $quantidadeOperador = $this->leadFactory->getQuantidadeProspectsOperador($parcOperador, $nrorg);
        
        if($quantidadeOperador >= $limite && $limite != 'SEM_LIMITE'){
            $excedeuLimite = true;
        }else{
            $excedeuLimite = false;
        }
        
        $return = array(
                    "EXCEDEULIMITE" => $excedeuLimite,
                    "LIMITE"        => $limite,
                    "QUANTIDADE"    => $quantidadeOperador
                  );
        
        return $return;
    }
    
    public function validaOperadorRevenda($row){
        
        $parcOperador   = $row['NRPARCPROPRI'];
        $nrorg      = $row['NRORG'];
        
        $limite = $this->leadFactory->getLimiteLeadsPorRevendaParametrizacao($nrorg);
        $quantidadeOperador = $this->leadFactory->getQuantidadeLeadsOperador($parcOperador, $nrorg);
        
        if($quantidadeOperador >= $limite && $limite != 'SEM_LIMITE'){
            $excedeuLimite = true;
        }else{
            $excedeuLimite = false;
        }
        
        $return = array(
                    "EXCEDEULIMITE" => $excedeuLimite,
                    "LIMITE"        => $limite,
                    "QUANTIDADE"    => $quantidadeOperador
                  );
        return $return;
    }
    
    public function prepareInsertLeadEvolutionNextTask($row){

        $row["NRSEQFILACONTA"] = $this->newCode->getCodeByTableName("FILACONTATO", $row["NRORG"]);

        
        $paramsInsertLeadEvolNextTask = array(
            "DSFILACONTATO"             => $row["DSFILACONTATO"],
            "DTPLANFILACONTA"           => $row["DTPLANFILACONTA"],
            "CDOPERREAL"                => $row["CDOPERREAL"],
            "NRSEQFILACONTA"            => $row["NRSEQFILACONTA"],
            "NRORG"                     => $row["NRORG"],
            "NRORGINCLUSAO"             => $row["NRORG"],
            "CDOPERINCLUSAO"            => $row["CDOPERREAL"],
            "NRPARCNEGOCIO"             => $row["NRPARCNEGOCIO"],
            "NRCONTATO"                 => $row["NRSEQCONTATO"],
            "NRSEQCONTATO"              => $row["NRSEQCONTATO"],
            "NRSEQCLASSIFICATAREFA"     => "2"
        );
        
        $this->leadFactory->insertLeadEvolNextTask($paramsInsertLeadEvolNextTask);
        
        return $row["NRSEQFILACONTA"];
        
    }
    
    public function callForSetTaskEndDate($row){
        
        $paramsSetTaskEndDate = array(
            
            "NRSEQFILACONTA"        => $row["NRSEQFILACONTA"]
            
        );
        
        $this->leadFactory->requestForSetTaskEndDate($paramsSetTaskEndDate);
        
    }
    
    public function callForDeactivateLeadTask($row){
        
        $paramsDeactivateTask = array(
            
            "NRSEQFILACONTA"        => $row["NRSEQFILACONTA"]
            
        );
        
        $this->leadFactory->requestForDeactivateLeadTask($paramsDeactivateTask);
        
    }
    
    public function callForInsertProspectInterlocutor($paramsInsertInterlocutor){
        
        $this->leadFactory->requestForInsertProspectInterlocutor($paramsInsertInterlocutor);
        
    }
    
    public function callToSetLeadIdAtivo($updateParams){
        
        $this->leadFactory->requestToSetLeadIdAtivo($updateParams);
        
    }
    
    public function callToInsertProspectToResale($paramsInsert){
        
        $paramsInsert["NRPROSPREVENDA"] = NovoCodigo::geraCodigo($paramsInsert["NRORG"], "CRM_PROSPREVENDA", 1, 10, false, false);
        
        $this->leadFactory->requestToInsertProspectToResale($paramsInsert);
        
    }
    
    public function callToUpdateLeadPartnership($insertParams){
        $this->leadFactory->requestToUpdateLeadPartnership($insertParams);
    }
    
    public function callToGetLeadPartnershipNumber($selectParams){
        
        $partnershipNumber = $this->leadFactory->requestToGetLeadPartnershipNumber($selectParams);
        return $partnershipNumber;
        
    }
    
    public function callToEditLeadResponsibleOperator($updateParams){
        $this->leadFactory->requestToEditLeadResponsibleOperator($updateParams);
    }
    
}
?>